From 80b974b35a6d38ea4f650db8c1e02cbc5f4bdb7c Mon Sep 17 00:00:00 2001
From: shynur <one.last.kiss@outlook.com>
Date: Tue, 30 Apr 2024 18:08:48 +0800
Subject: [PATCH] Locate error source of ExceptionGroup in Python shell

---
 etc/NEWS                 | 8 ++++++++
 lisp/progmodes/python.el | 2 +-
 2 files changed, 9 insertions(+), 1 deletion(-)

diff --git a/etc/NEWS b/etc/NEWS
index 4b0106fcb07..f7da11b67c9 100644
--- a/etc/NEWS
+++ b/etc/NEWS
@@ -1347,6 +1347,14 @@ instead of:
 This allows the user to specify command line arguments to the non
 interactive Python interpreter specified by 'python-interpreter'.
 
+** Inferior Python mode
+
+---
+*** Default value of 'python-shell-compilation-regexp-alist' is changed.
+Support for Python's ExceptionGroup has been added, so in the Python
+shell, the line indicating the source of error in the error messages
+from ExceptionGroup will be recognized as well.
+
 ** Scheme mode
 Scheme mode now handles regular expression literal '#/regexp/' that is
 available in some Scheme implementations.
diff --git a/lisp/progmodes/python.el b/lisp/progmodes/python.el
index d6c29e5ffc6..3f72295c808 100644
--- a/lisp/progmodes/python.el
+++ b/lisp/progmodes/python.el
@@ -2854,7 +2854,7 @@ virtualenv."
   :type '(repeat symbol))
 
 (defcustom python-shell-compilation-regexp-alist
-  `((,(rx line-start (1+ (any " \t")) "File \""
+  `((,(rx line-start (1+ (any " \t")) (? ?| (1+ (any " \t"))) "File \""
           (group (1+ (not (any "\"<")))) ; avoid `<stdin>' &c
           "\", line " (group (1+ digit)))
      1 2)
-- 
2.43.0

